hdu1685 GCD 容斥原理

//数x小于等于b大于0的任意一个数,数y为小于等于d大于0的任意一个

//问有多少对x,y使得gcd(x,y) = k ;

//且(x,y),(y,x)算一对

//可以转化为[1, b/k]中的x , 和 [1,d/k]中的y,

//使得gcd(x,y) = 1

//可以枚举x , 在[1,d/k] 的范围内找大于x,且与x互质的数有多少个

//记录所有x的素数因子

//容斥原理可得:所有不与x互素的数的个数= 1个素数因子倍数的个数 - 2个素数因子乘积的倍数的个数 + 3个……-……

#include<cstdio>

#include<cstring>

#include<iostream>

#include<vector>

using namespace std ;

const int maxn = 100010 ;

typedef __int64 ll ;

vector<int> vec[maxn] ;

int isp[maxn] ;

void set()

{

memset(isp, 0  ,sizeof(isp)) ;

for(int i = 2;i < maxn;i+=2)

vec[i].push_back(2) ;

for(int i = 3;i < maxn;i+=2)

{

if(!isp[i])

for(int j = i ;j < maxn;j+=i)

{

if(j != i)isp[j] = 1;

vec[j].push_back(i) ;

}

}

}

ll dfs(int pos , int x , int d)//在(1,d)范围内找与x不互素的数的个数

{

ll ans = 0 ;

for(int i = pos ;i < vec[x].size() ;i++)

ans += d/vec[x][i] - dfs(i+1 , x , d/vec[x][i]) ;

return ans ;

}

int main()

{

int T ;

set() ;

int cas = 0 ;

scanf("%d" , &T) ;

while(T--)

{

int a ,b ,c , d , k;

scanf("%d%d%d%d%d" , &a , &b, &c,  &d , &k) ;

printf("Case %d: " , ++cas) ;

if(k == 0)

{

puts("0") ;

continue ;

}

if(b > d)swap(b , d) ;

b/=k ; d/=k;

ll ans = 0 ;

for(int i = 1;i <= b;i++)

ans += (ll)(d - i + 1) - dfs(0 , i , d) + dfs(0 , i , i-1) ;

printf("%I64d\n" , ans) ;

}

}

时间: 2024-11-06 12:03:05

hdu1685 GCD 容斥原理的相关文章

HDU 1695 GCD (容斥原理+质因数分解)

先进行预处理,对每一个数分解质因数. 然后将因为若gcd(x,y)==z,那么gcd(x/z,y/z)==1,又因为不是z的倍数的肯定不是,所以不是z的倍数的可以直接去掉,所以只要将b和d除以k,然后就转化成了求两个范围中互质的对数了.这时候可以枚举1~b,然后用容斥原理找1~d范围内的与枚举数互质的数的个数,为了避免重复,只要再限定下大小关系就可以了,具体见代码. 代码如下: #include <iostream> #include <string.h> #include <

hdu (欧拉函数+容斥原理) GCD

题目链接http://acm.hdu.edu.cn/showproblem.php?pid=1695 看了别人的方法才会做 参考博客http://blog.csdn.net/shiren_Bod/article/details/5787722 题意 a,b,c,d,k五个数,a与c可看做恒为1,求在a到b中选一个数x,c到d中选一个数y,使得gcd(x,y)等于k,求x和y有多少对. 首先可以想到选取的必是k的倍数,假设是x和y倍,则x和y一定是互质的在,那么就变成了求1到b/k和1到d/k的之

HDU 1695 GCD 欧拉函数+容斥原理+质因数分解

链接:http://acm.hdu.edu.cn/showproblem.php?pid=1695 题意:在[a,b]中的x,在[c,d]中的y,求x与y的最大公约数为k的组合有多少.(a=1, a <= b <= 100000, c=1, c <= d <= 100000, 0 <= k <= 100000) 思路:因为x与y的最大公约数为k,所以xx=x/k与yy=y/k一定互质.要从a/k和b/k之中选择互质的数,枚举1~b/k,当选择的yy小于等于a/k时,可以

GCD HDU - 1695 (容斥原理)

GCD HDU - 1695 题意:给你5个数a,b,c,d,k.x属于[a,b]y属于[c,d]. 问你有多少对(x,y)的公约数为k.  注意(x,y)和 (y,x)视为同一对,a和c为1. 通过b/k,d/k,等价于把区间除以k,那么就变成了求有多少对(x,y)互素. 欧拉函数+容斥原理. 注意k可能为0. 1 #include <bits/stdc++.h> 2 using namespace std; 3 #define ll long long 4 const int maxn=1

hdu 1695 GCD(欧拉函数+容斥原理)

http://acm.hdu.edu.cn/showproblem.php? pid=1695 非常经典的题.同一时候感觉也非常难. 在区间[a,b]和[c,d]内分别随意取出一个数x,y,使得gcd(x,y) = k.问这种(x,y)有多少对.能够觉得a,c均为1,并且gcd(5,7)与gcd(7,5)是同一种. 由于gcd(x,y) = k,那么gcd(x/k,y/k) = 1.也就是求区间[1,b/k]和[1,d/k]内这种(x,y)对使得gcd(x,y) = 1. 为了防止计数反复,首先

HDU 1695 GCD (数论-整数和素数,组合数学-容斥原理)

GCD Problem Description Given 5 integers: a, b, c, d, k, you're to find x in a...b, y in c...d that GCD(x, y) = k. GCD(x, y) means the greatest common divisor of x and y. Since the number of choices may be very large, you're only required to output t

HDU 1695 GCD(欧拉函数+容斥原理)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1695 题意:x位于区间[a, b],y位于区间[c, d],求满足GCD(x, y) = k的(x, y)有多少组,不考虑顺序. 思路:a = c = 1简化了问题,原问题可以转化为在[1, b/k]和[1, d/k]这两个区间各取一个数,组成的数对是互质的数量,不考虑顺序.我们让d > b,我们枚举区间[1, d/k]的数i作为二元组的第二位,因为不考虑顺序我们考虑第一位的值时,只用考虑小于i的情

hdu 1695 GCD (欧拉函数、容斥原理)

GCD Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 7357    Accepted Submission(s): 2698 Problem Description Given 5 integers: a, b, c, d, k, you're to find x in a...b, y in c...d that GCD(x, y

hdu 1695 GCD【欧拉函数+容斥原理】

GCD Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 6253    Accepted Submission(s): 2291 Problem Description Given 5 integers: a, b, c, d, k, you're to find x in a...b, y in c...d that GCD(x, y